package automated;

public class NonEmptyList<A> implements MyList<A> {
    // begin instance variables
    public final A element;
    public final MyList<A> tail;
    // end instance variables

    public NonEmptyList(final A element,
                        final MyList<A> tail) {
        this.element = element;
        this.tail = tail;
    }

    public MyList<A> reverse() {
        MyList<A> current = this;
        MyList<A> result = new EmptyList<A>();

        while (current instanceof NonEmptyList) {
            final NonEmptyList<A> currentList = (NonEmptyList<A>)current;
            result = new NonEmptyList<A>(currentList.element, result);
            current = currentList.tail;
        }

        return result;
    }
    
    public int length() {
        return 1 + tail.length();
    }

    public MyList<A> append(final MyList<A> other) {
        return new NonEmptyList<A>(element,
                                   tail.append(other));
    }

    public boolean equals(final Object other) {
        if (other instanceof NonEmptyList) {
            final NonEmptyList<A> otherList =
                (NonEmptyList<A>)other;
            return (element.equals(otherList.element) &&
                    tail.equals(otherList.tail));
        } else {
            return false;
        }
    }
}
