package automated;

import java.util.Random;

import static org.junit.Assert.assertEquals;
import org.junit.Test;

public class AutomatedMinTest {
    public static final int MIN_START = -100;
    public static final int MIN_END = 100;

    public static final long RANDOM_SEED = 123;
    public static final int NUM_RANDOM_TESTS = 1000;
    
    @Test
    public void testMinBoundedExhaustive() {
        for (int small = MIN_START; small < MIN_END; small++) {
            for (int big = small + 1; big <= MIN_END; big++) {
                assertEquals(small, Min.min(small, big));
                assertEquals(small, Min.min(big, small));
                assertEquals(small, Min.min(small, small));
                assertEquals(big, Min.min(big, big));
            }
        }
    }

    @Test
    public void testMinRandom() {
        final Random random = new Random(RANDOM_SEED);
        for (int testNumber = 0; testNumber < NUM_RANDOM_TESTS; testNumber++) {
            final int small = MIN_START + random.nextInt(MIN_END - MIN_START);
            final int big = small + 1;
            assertEquals(small, Min.min(small, big));
            assertEquals(small, Min.min(big, small));
            assertEquals(small, Min.min(small, small));
            assertEquals(big, Min.min(big, big));
        }
    }
}
